unit nibblevl;
{ random = 88, standard = 99 }
{ Werte im Feld:
  1 - maxplayer: Spieler-Nummer
  101 - 109: blaue Zahlen
  111 - 119: rote Zahlen
  0: leeres Feld
  99: Mauer
}
INTERFACE
uses
  crt, dos, nibbserv, nibbMenu, nibbText;
const
  maxplayer = 5;
  sMaxplayer = '5';
  mapDir = '.\maps';
  leeresFeld = 0;
  mauerFeld = 99;
type
  spielerFarbTyp = array[ 1..maxplayer ] of byte;
var
  levelName: string[8];
  feld: array[1..80, 1..48] of byte;
  startpos: array[1..maxplayer] of record
                                     richtung, x, y: byte
                                   end;

  function auswahl(nBodenFarb, nWandFarb: byte; nSpielerFarbe: spielerFarbTyp): boolean;
  procedure zuHintergrund(xpos, ypos: byte);
  procedure malSchlange(xpos, ypos, nummer: byte);
  function feldFarbe( feldWert: byte ): byte;

IMPLEMENTATION
var
  bodenFarbe, wandFarbe: byte;
  spielerFarbe: spielerFarbTyp;

function feldFarbe( feldWert: byte ): byte;
begin
  case feldWert of
    leeresFeld: feldFarbe := bodenFarbe;
    mauerFeld: feldFarbe := wandFarbe;
    1 .. maxplayer: feldFarbe := spielerFarbe[ feldWert ];
  end;
end;

procedure malSchlange(xpos, ypos, nummer: byte);
begin
  feld[xpos, ypos]:= nummer;
  gotoxy(xpos, (ypos + 1) div 2);
  textbackground( feldFarbe( nummer ) );
  if odd(ypos) then
  begin
    textcolor( feldFarbe( feld[xpos,(ypos + 1)] ) );
    write(char(220));
  end
  else
  begin
    textcolor( feldFarbe( feld[xpos,(ypos - 1)] ) );
    write(char(223));
  end;
end;

procedure zuHintergrund(xpos, ypos: byte);
begin
  feld[xpos, ypos]:= leeresFeld;
  gotoxy(xpos, (ypos + 1) div 2);
  textcolor( feldFarbe( leeresFeld ) );
  if odd(ypos) then
   if feld[xpos, (ypos + 1)] = leeresFeld then write(char(219)) else
    begin
      textbackground( feldFarbe( feld[xpos,(ypos + 1)] ) );
      write(char(223));
    end
  else
   if feld[xpos, (ypos - 1)] = leeresFeld then write(char(219)) else
    begin
      textbackground( feldFarbe( feld[xpos,(ypos - 1)] ) );
      write(char(220));
    end;
end;

procedure init(nBodenFarb, nWandFarb, nAussenWand: byte);
var
  i, j: byte;
  datei: text;
  zeile: string;
begin
  if nBodenFarb < 16 then bodenFarbe:= nBodenFarb
                     else bodenFarbe:= random(8) + 8;
  if nWandFarb < 8 then wandFarbe:= nWandFarb
                   else wandFarbe:= random(8);
  for i:= 1 to maxplayer do
    with startpos[i] do
    begin
      richtung:= 2;
      x:= 30;
      y:= 7 * i;
    end;
  assign(datei, mapDir + '\' + erweiterung(levelName, '.vnl'));
  {$i-}
  reset(datei);
  {$i+}
  if ioresult > 0 then
  begin
    writeln;
    writeln('Error opening ''', mapDir + '\' + erweiterung(levelName, '.vnl'), '''!');
    write(' Press <Enter> to continue...');
    readln;
    levelName:= ' ';
  end;
  clrscr;
  i:= 0;
  textbackground(wandFarbe);
  textcolor(bodenFarbe);
  while i < 24 do
  begin
    if levelName <> ' ' then
      if not eof(datei) then readln(datei, zeile) else zeile:=' ';
    case upcase(zeile[1]) of { zeile[1] }
    'W': begin
           if nWandFarb = 99 then wandFarbe:= zeilenEndWert(zeile);
           textbackground(wandFarbe);
         end;
    'B': begin
           if nBodenFarb = 99 then bodenFarbe:= zeilenEndWert(zeile);
           textcolor(bodenFarbe);
         end;
    '/': if zeile[2] = '/' then;
    else
      begin
        inc(i);
        zeile:= txtLaenge(zeile, 80); {Zeile auf Laenge 80 bringen}
        for j:= 1 to length(zeile) do
        case zeile[j] of {von zeile}
          char(219): begin {}
                       write(' ');
                       feld[j, (i * 2 - 1)]:= mauerFeld;
                       feld[j, (i * 2)]:= mauerFeld;
                     end;
          char(223): begin {}
                       write(char(220));
                       feld[j, (i * 2 - 1)]:= mauerFeld;
                       feld[j, (i * 2)]:= leeresFeld;
                     end;
          char(220): begin {}
                       write(char(223));
                       feld[j, (i * 2 - 1)]:= leeresFeld;
                       feld[j, (i * 2)]:= mauerFeld;
                     end;
          '1'.. sMaxplayer:
                     begin
                       with startpos[str2int(zeile[j])] do
                       begin
                         x:= j;
                         y:=(i * 2);
                         if zeile[j + 1] = 'U' then inc(y) else
                         if zeile[j + 1] = upcase(zeile[j + 1]) then dec(y);
                         case zeile[j + 1] of {up, down, left, right}
                           'u', 'U': richtung:= 1;
                           'd', 'D': begin
                                       richtung:= 3;
                                       dec(y);
                                     end;
                           'l', 'L': begin
                                       richtung:= 4;
                                       inc(x);
                                     end;
                           'r', 'R': richtung:= 2;
                         end;
                       end;
                       write(char(219) + char(219));
                       feld[j, (i * 2 - 1)]:= leeresFeld;
                       feld[j, (i * 2)]:= leeresFeld;
                       inc(j);
                       feld[j, (i * 2 - 1)]:= leeresFeld;
                       feld[j, (i * 2 )]:= leeresFeld;
                     end;
          else       begin { }
                       write(char(219));
                       feld[j, (i * 2 - 1)]:= leeresFeld;
                       feld[j, (i * 2)]:= leeresFeld;
                     end;
        end; {von case zeile}
      end;
    end; { zeile[1] }
  end;
  if levelName <> ' ' then close(datei);
  if nAussenwand > 1 then
  begin
    for i:= 1 to 80 do
      if nAussenwand = 2 then
      begin
        malSchlange(i, 1, mauerFeld);
        malSchlange(i, 48, mauerFeld);
      end
      else
      begin
        zuHintergrund(i, 1);
        zuHintergrund(i, 48);
      end;
    for i:= 2 to 47 do
      if nAussenwand = 2 then
      begin
        malSchlange(1, i, mauerFeld);
        malSchlange(80, i, mauerFeld);
      end
      else
      begin
        zuHintergrund(1, i);
        zuHintergrund(80, i);
      end;
  end;
end;

function auswahl(nBodenFarb, nWandFarb: byte; nSpielerFarbe: spielerFarbTyp): boolean;
type
  zeiger = ^daten;
  daten = record
            inhalt: string[12];
            vor, zurueck: zeiger;
          end;
var
  DirInfo: SearchRec;
  pNames, lauf: zeiger;
  ch: char;
  aussenWand: byte;
  function findeStelle(name: string; stelle: zeiger): zeiger;
  begin
    if stelle <> nil then
      while ((stelle^.vor <> nil) and (name <> stelle^.inhalt)) do
        stelle:= stelle^.vor;
    findeStelle:= stelle;
  end;
  procedure einfuegen(neuName: string; var stelle: zeiger);
  var
    neu, lauf: zeiger;
    ende: boolean;
  begin
    new(neu);
    neu^.inhalt:= neuName;
    ende:= false;
    lauf:= stelle;
    if stelle = nil then
    begin
      stelle:= neu;
      stelle^.vor:= nil;
      stelle^.zurueck:= nil;
    end
    else
    repeat
      if gr(neu^.inhalt) < gr(lauf^.inhalt) then
      begin                   {vor lauf anfgen}
        neu^.vor:= lauf;
        neu^.zurueck:= lauf^.zurueck;
        if lauf^.zurueck = nil then stelle:=neu
                               else lauf^.zurueck^.vor:= neu;
        lauf^.zurueck:= neu;
        ende:= true;
      end
      else
      if lauf^.vor = nil then
      begin                  {am Ende der List anfgen}
        lauf^.vor:= neu;
        neu^.vor:= nil;
        neu^.zurueck:= lauf;
        ende:= true;
      end
      else lauf:= lauf^.vor;
    until ende;
  end;
  procedure loescheListe;
  var
    temp: zeiger;
  begin
    while pNames <> nil do
    begin
      temp:= pNames;
      pNames:= pNames^.vor;
      dispose(temp);
    end;
    pNames:= nil;
  end;
begin
  spielerFarbe := nSpielerFarbe;
  aussenWand:= 1;
  pNames:= nil;
  FindFirst(mapDir + '\' + '*.vnl', Archive, DirInfo);
  while DosError = 0 do
  begin
    einfuegen(nibbserv.nurName(DirInfo.Name), pNames);
    FindNext(DirInfo);
  end;
  lauf:= findeStelle(levelName, pNames);
  repeat
    if lauf = nil then levelName:= ' ' else levelName:= lauf^.inhalt;
    init(nBodenFarb, nWandFarb, aussenWand);
    nibbMenu.hilfText(' ''' + levelName + '''  ' + nibbText.levelWahlTxt + ': ' + int2str(aussenWand), false);
    ch:= readkey;
    if ord(ch) = 0 then ch:= readkey;
    case upcase(ch) of
      'K', 'P': if lauf^.zurueck <> nil then lauf:= lauf^.zurueck;
      'H', 'M': if lauf^.vor <> nil then lauf:= lauf^.vor;
      '1', '2', '3': aussenWand:= str2int(ch);
    end;
  until ((ch = char(13)) or (ch = char(27)));
  loescheListe;
  textbackground( wandFarbe );
  gotoxy(1, 25);
  clreol;
  auswahl:= (ch = char(13));
end; {procedure auswahl}

end.