unit nibbuffr;

INTERFACE
type
  pEingabe = ^tEingabe;
  tEingabe = record
               inhalt: byte;
               verweis: pEingabe;
             end;
  pBuffer = ^tBuffer;
  tBuffer = object
             vorne, hinten: pEingabe;
             constructor init( x: byte);
             procedure put(x: byte; relPut: boolean);
             function get: byte;
             destructor ende;
           end;

IMPLEMENTATION

constructor tBuffer.init(x: byte);
begin
  new(vorne);
  vorne^.inhalt:= x;
  vorne^.verweis:= nil;
  hinten:= vorne;
end;

procedure tBuffer.put(x: byte; relPut: boolean);
var
  relLeft: boolean;
  procedure putNow;
  var
    temp: pEingabe;
  begin
    new(temp);
    temp^.verweis:= nil;
    temp^.inhalt:= x;
    hinten^.verweis:= temp;
    hinten:= temp;
  end;
begin
  if relPut then
  begin
    relLeft:= (x = 4);
    x:= hinten^.inhalt;
    if relLeft then {rechts gedrckt}
    begin
      if x > 1 then dec(x) else x:= 4;
    end
    else
      if x < 4 then inc(x) else x:= 1;
    putNow;
  end
  else
  if ( (hinten^.inhalt <> x) and {nicht in die gleiche Richtung laufen und..}
    odd(hinten^.inhalt + x) ) {nicht in Gegenrichtung laufen}
  then putNow;

end;

function tBuffer.get: byte;
var
  temp: pEingabe;
begin
  if vorne^.verweis <> nil then {wenn es neue Eingabe gibt: alte lschen}
  begin
    temp:= vorne;
    vorne:= vorne^.verweis;
    dispose(temp);
  end;
  get:= vorne^.inhalt;
end;

destructor tBuffer.ende;
var
  temp: pEingabe;
begin
  hinten:= nil;
  while vorne <> nil do
  begin
    temp:= vorne;
    vorne:= vorne^.verweis;
    dispose(temp);
  end;
end;

end.