unit nibbljoy; {Variante A - schneller}

INTERFACE
const
  j1l = 201; j1r = 202; j1o = 203; j1u = 204;
  j2l = 205; j2r = 206; j2o = 207; j2u = 208;

  procedure abfragen(anzahl: byte);
  procedure init(n: byte; zeile: string);
  procedure calibrate(n: byte);
  function infoZeile(n: byte): string;
  function richtung(n: byte): byte;

IMPLEMENTATION
uses
  joystick, nibbserv, crt, nibbtext;
type
  vJoyRec = record
             midX, midY, maxX, maxY, minX, minY, xTolernc, yTolernc: integer;
             richtung, altKey: byte;
           end;

var
  vJoy : array [1..2] of vJoyRec;

function bereich(wert, punkt, toleranz: integer): boolean;
begin
  bereich:= ( (wert < (punkt + toleranz)) and (wert > (punkt - toleranz)) );
end;

function j1richtung: byte;
var
  x, y: integer;
  richtung: byte;
begin
  richtung:= 0;
  x:= gSticks[1].x;
  y:= gSticks[1].y;
  if bereich(x, vJoy[1].minX, vJoy[1].xTolernc) then richtung:= j1l else
  if bereich(x, vJoy[1].maxX, vJoy[1].xTolernc) then richtung:= j1r else
  if bereich(y, vJoy[1].minY, vJoy[1].yTolernc) then richtung:= j1o else
  if bereich(y, vJoy[1].maxY, vJoy[1].yTolernc ) then richtung:= j1u;
  j1richtung:= richtung;
end;

function j2richtung: byte;
var
  x, y: integer;
  richtung: byte;
begin
  richtung:= 0;
  x:= gsticks[2].x;
  y:= gsticks[2].y;
  if bereich(x, vJoy[2].minX, vJoy[2].xTolernc) then richtung:= j2l else
  if bereich(x, vJoy[2].maxX, vJoy[2].xTolernc) then richtung:= j2r else
  if bereich(y, vJoy[2].minY, vJoy[2].yTolernc) then richtung:= j2o else
  if bereich(y, vJoy[2].maxY, vJoy[2].yTolernc) then richtung:= j2u;
  j2richtung:= richtung;
end;

procedure calibrate(n: byte);
var
  x, y, xt, yt: integer;
  procedure werteLesen(nachricht: string);
  begin
    abfragen(n);
    x:= gsticks[n].x;
    y:= gsticks[n].y;
    if x > vJoy[n].maxX then vJoy[n].maxX:= x;
    if x < vJoy[n].minX then vJoy[n].minX:= x;
    if y > vJoy[n].maxY then vJoy[n].maxY:= y;
    if y < vJoy[n].minY then vJoy[n].minY:= y;
    xt:= ((vJoy[n].midx - vJoy[n].minx) div 2);
    vJoy[n].xTolernc:= ((vJoy[n].maxX - vJoy[n].midX) div 2);
    if xt < vJoy[n].xTolernc then vJoy[n].xTolernc:= xt;
    yt:= ((vJoy[n].midY - vJoy[n].minY) div 2);
    vJoy[n].yTolernc:= ((vJoy[n].maxY - vJoy[n].midY) div 2);
    if yt < vJoy[n].yTolernc then vJoy[n].yTolernc:= yt;
    gotoxy(1, 4);
    writeln('  minX: ', vJoy[n].minX:3, '  midX: ', vJoy[n].midX:3, '  maxX: ', vJoy[n].maxX:3);
    writeln('  minY: ', vJoy[n].minY:3, '  midY: ', vJoy[n].midY:3, '  maxY: ', vJoy[n].maxY:3);
    writeln;
    writeln('    x-value: ', x:5, '  y-value: ', y:5);
    writeln;
    writeln(' xTolerance: ', vJoy[n].xTolernc);
    writeln(' yTolerance: ', vJoy[n].yTolernc);
    writeln(' "Key": ', vJoy[n].richtung:5);
    writeln;
    textcolor(red);
    writeln(' ' + nachricht);
    textcolor(black);
    writeln(' ' + nibbText.joyKnopfTxt);
  end;
begin
  textbackground(lightgray);
  textcolor(black);
  clrscr;
  writeln;
  writeln('     Calibrate Joystick ', n);
  repeat
    werteLesen(nibbText.joyZentrierTxt);
  until gsticks[n].button1 or keypressed;
  x:= gsticks[n].x;
  y:= gsticks[n].y;
  vJoy[n].midX:= x;  vJoy[n].midY:= y;  vJoy[n].maxX:= x;
  vJoy[n].maxY:= y;  vJoy[n].minX:= x;  vJoy[n].minY:= y;
  gotoxy(1, 4);
  clreol;
  repeat
    abfragen(n);
  until not(gsticks[n].button1) or keypressed;
  repeat
    werteLesen(nibbText.joyBewegeTxt);
  until gsticks[n].button1 or keypressed;
  clrscr;
end;

function infoZeile(n: byte): string;
begin
  infoZeile:= int2str(vJoy[n].minX) + ' ' + int2str(vJoy[n].midX) + ' ' + int2str(vJoy[n].maxX) +
    ' ' + int2str(vJoy[n].minY) + ' ' + int2str(vJoy[n].midY) + ' ' + int2str(vJoy[n].maxY) + ' ' +
    int2str(vJoy[n].xTolernc) + ' ' + int2str(vJoy[n].yTolernc);
end;


procedure init(n: byte; zeile: string);
begin
  joystick.initSticks;
  vJoy[n].yTolernc:= zeilenEndWert(zeile);
  vJoy[n].xTolernc:= zeilenEndWert(zeile);
  vJoy[n].maxY:= zeilenEndWert(zeile);
  vJoy[n].midY:= zeilenEndWert(zeile);
  vJoy[n].minY:= zeilenEndWert(zeile);
  vJoy[n].maxX:= zeilenEndWert(zeile);
  vJoy[n].midX:= zeilenEndWert(zeile);
  vJoy[n].minX:= zeilenEndWert(zeile);
  vJoy[n].richtung:= 0;
end;

function richtung(n: byte): byte;
begin
  if vJoy[n].richtung = vJoy[n].altKey then richtung:= 0
                                       else richtung:= vJoy[n].richtung;
end;

procedure abfragen(anzahl: byte);
begin
  if anzahl > 0 then
  begin
    vJoy[1].altKey:= vJoy[1].richtung;
    vJoy[2].altKey:= vJoy[2].richtung;
    joystick.pollsticks;
    vJoy[1].richtung:= j1richtung;
    if anzahl = 2 then
      vJoy[2].richtung:= j2richtung;
  end;
end;

end.